import statsmodels.api as sm
import pandas as pd 
import xlwings as xw
import numpy as np
import pyttsx3

def get_column_letter(num):
    letters = ''
    while num:
        mod = (num - 1) % 26
        letters += chr(mod + 65)
        num = (num - 1) // 26
    return ''.join(reversed(letters))
    
def fx(x,pwr):
  if pwr > 0:
    return x**pwr
  elif pwr < 0:
    return 1/x**abs(pwr)
  else:
    return np.log(x)

def calcColumns(sheet):
  col = 0
  while 1:
    col += 1
    if sheet.range(1,col).value is None:
      break
  return col-1

e = pyttsx3.init()
rate = e.getProperty('rate')
e.setProperty('rate', rate-50)

# Load your data (replace with your actual data)
wb = xw.Book('bestmlr3.xlsx')
sheetData = wb.sheets['Data']
sheetTransf = wb.sheets['Transf']
sheetRes = wb.sheets['Results']
sheetList = wb.sheets['List']
sheetYt = wb.sheets['Yt']
sheetXt1 = wb.sheets['Xt1']
sheetXt2 = wb.sheets['Xt2']
sheetXt3 = wb.sheets['Xt3']
# clear sheets
sheetList.range('A2:Z10000').value = ""
sheetYt.range('A1:Z10000').value = ""
sheetXt1.range('A1:Z10000').value = ""
sheetXt2.range('A1:Z10000').value = ""
sheetXt3.range('A1:Z10000').value = ""

row = 1
while 1:
  row += 1
  if sheetData.range(row,1).value is None:
    break
maxrows = row - 1

yPwrs = sheetTransf.range("A2:A4").value
x1Pwrs = sheetTransf.range("B2:B4").value
x2Pwrs = sheetTransf.range("C2:C4").value
x3Pwrs = sheetTransf.range("D2:D4").value
minAdjR2 = sheetTransf.range("E2").value
yCols = 0
for yPwr in np.arange(yPwrs[0],yPwrs[2]+yPwrs[1],yPwrs[1]):
  yCols += 1
  for row in range(2,maxrows+1):
    sheetYt.range(row-1,yCols).value = fx(sheetData.range(row,1).value,yPwr)

x1Cols = 0
for x1Pwr in np.arange(x1Pwrs[0],x1Pwrs[2]+x1Pwrs[1],x1Pwrs[1]):
  x1Cols += 1
  for row in range(2,maxrows+1):
    sheetXt1.range(row-1,x1Cols).value = fx(sheetData.range(row,2).value,x1Pwr)

x2Cols = 0
for x2Pwr in np.arange(x2Pwrs[0],x2Pwrs[2]+x2Pwrs[1],x2Pwrs[1]):
  x2Cols += 1
  for row in range(2,maxrows+1):
    sheetXt2.range(row-1,x2Cols).value = fx(sheetData.range(row,3).value,x2Pwr)

x3Cols = 0
for x3Pwr in np.arange(x3Pwrs[0],x3Pwrs[2]+x3Pwrs[1],x3Pwrs[1]):
  x3Cols += 1
  for row in range(2,maxrows+1):
    sheetXt3.range(row-1,x3Cols).value = fx(sheetData.range(row,4).value,x3Pwr)


bestAdjR2 = 0
gRow = 1

e.say("Initialization Done")
e.runAndWait()

yCols = 0
for yPwr in np.arange(yPwrs[0],yPwrs[2]+yPwrs[1],yPwrs[1]):
  yCols += 1
  s = get_column_letter(yCols)
  s2 = s + "1:" + s + str(maxrows-1)
  Ysr = sheetYt.range(s2)
  Ysr.copy()
  Ydr = sheetData.range("E2")
  Ydr.paste()

  x1Cols = 0  
  for x1Pwr in np.arange(x1Pwrs[0],x1Pwrs[2]+x1Pwrs[1],x1Pwrs[1]):
    x1Cols += 1
    s = get_column_letter(x1Cols)
    s2 = s + "1:" + s + str(maxrows-1)
    Xsr = sheetXt1.range(s2)
    Xsr.copy()
    Xdr = sheetData.range("F2")
    Xdr.paste()

    x2Cols = 0  
    for x2Pwr in np.arange(x2Pwrs[0],x2Pwrs[2]+x2Pwrs[1],x2Pwrs[1]):
      x2Cols += 1
      s = get_column_letter(x2Cols)
      s2 = s + "1:" + s + str(maxrows-1)
      Xsr = sheetXt2.range(s2)
      Xsr.copy()
      Xdr = sheetData.range("G2")
      Xdr.paste()

      x3Cols = 0  
      for x3Pwr in np.arange(x3Pwrs[0],x3Pwrs[2]+x3Pwrs[1],x3Pwrs[1]):
        x3Cols += 1
        s = get_column_letter(x3Cols)
        s2 = s + "1:" + s + str(maxrows-1)
        Xsr = sheetXt3.range(s2)
        Xsr.copy()
        Xdr = sheetData.range("H2")
        Xdr.paste()
    
        data = sheetData.range((2,5),(maxrows,8)).value
    
        # Convert data to a pandas DataFrame
        df = pd.DataFrame(data)
        df.columns = ['Yt','Xt1','Xt2','Xt3']
        # Define dependent and independent variables
        y = df['Yt']
        X = df[['Xt1','Xt2','Xt3']]
        # Add a constant to the independent variables (for the intercept term)
        X = sm.add_constant(X)

        # Fit the model
        model = sm.OLS(y, X).fit()
    
        if model.rsquared_adj > bestAdjR2:
          bestAdjR2 = model.rsquared_adj
          bestYpwr = yPwr
          bestX1pwr = x1Pwr
          bestX2pwr = x2Pwr
          bestX3pwr = x3Pwr
          bestModel = model

        if model.rsquared_adj >= 0.0:
          gRow += 1
          sheetList.range((gRow,1)).value = model.rsquared_adj
          sheetList.range((gRow,2)).value = yPwr
          sheetList.range((gRow,3)).value = x1Pwr
          sheetList.range((gRow,4)).value = x2Pwr
          sheetList.range((gRow,5)).value = x3Pwr
          sheetList.range((gRow,6)).value= model.params.iloc[0]
          sheetList.range((gRow,7)).value= model.params.iloc[1]
          sheetList.range((gRow,8)).value= model.params.iloc[2]
          sheetList.range((gRow,9)).value= model.params.iloc[3]

model = bestModel

# Print the summary of the best regression results
print(model.summary())
print("Best Y power", bestYpwr)
print("Best X1 power", bestX1pwr)
print("Best X2 power", bestX2pwr)
print("Best X3 power", bestX3pwr)

sheetRes.range("B1").value = model.rsquared_adj
sheetRes.range("B2").value = model.fvalue
sheetRes.range("B3").value = model.f_pvalue
sheetRes.range("B4").value = model.aic
sheetRes.range("D2").value = bestYpwr
sheetRes.range("F2").value = bestX1pwr
sheetRes.range("G2").value = bestX2pwr
sheetRes.range("H2").value = bestX3pwr
sheetRes.range("E3").value = model.params.iloc[0]
sheetRes.range("F3").value = model.params.iloc[1]
sheetRes.range("G3").value = model.params.iloc[2]
sheetRes.range("H3").value = model.params.iloc[3]
sheetRes.range("E4").value = model.pvalues.iloc[0]
sheetRes.range("F4").value = model.pvalues.iloc[1]
sheetRes.range("G4").value = model.pvalues.iloc[2]
sheetRes.range("H4").value = model.pvalues.iloc[3]

e.say("Calculations Done")
e.runAndWait()